<?php
// $Id: guidance.block.inc,v 1.1 2009/08/16 07:55:49 itarato Exp $


/**
 * Define a block.
 * @param int $nid
 * @return array
 */
function guidance_create_block($nid) {
	if (!guidance_is_run($nid)) return;
	
  $guide = guidance_get_guide($nid);
  $links = guidance_get_guide_links($nid);
  if (empty($links)) return;

  $content = '';

  // No header necessary
  //$header = array(empty($guide->title) ? t('Guide') : check_plain($guide->title));
  $rows = array();
  foreach ((array)$links as $link) {
    $rows[] = array(l(
      _guidance_title_format($link['title'], $link['url']),
      ($link['lid']) ? 'guide/'.$nid.'/'.$link['lid'] : $link['url'],
      array('attributes' => array('class' => 'guide'.($link['visited'] ? ' visited' : '')))
    ));
  }
  $content = !empty($guide->teaser) ? theme('markup', array('#value' => $guide->teaser)).l(t('More information...'), 'node/'.$nid).'</p>' : '';
  $content .= theme('table', $header, $rows);
	$content .= drupal_get_form('guidance_block_closer_form_'.$nid, $nid);

  $block['subject'] = _guidance_title_format($guide->title, t('Guide'));
  $block['content'] = $content;

	drupal_alter('guidance_block', $block, $nid);
  
  return $block;
}


/**
 * Define a guide runner block
 */
function guidance_create_runner_block($nid) {
	if (guidance_is_run($nid)) return;
	
	$guide = guidance_get_guide($nid);
	$content = !empty($guide->teaser) ? theme('markup', array('#value' => $guide->teaser)).l(t('More information...'), 'node/'.$nid).'</p>' : '';
	$content .= drupal_get_form('guidance_block_runner_form_'.$nid, $nid);
	$block['subject'] = _guidance_title_format($guide->title, t('Guide'));
	$block['content'] = $content;
	
	drupal_alter('guidance_block', $block, $nid);
	
	return $block;
}


/**
 * Form for the START button on the runner form.
 */
function guidance_block_runner_form($form_original, $nid) {
	return array(
		'nid' => array(
			'#type' => 'hidden',
			'#value' => $nid,
		),
		'submit' => array(
			'#type' => 'submit',
			'#value' => 'Start guide',
		),
    '#submit' => array('guidance_block_runner_form_submit'),
	);
}


/**
 * Submission for the start button on the runner form.
 */
function guidance_block_runner_form_submit($form, $form_state) {
	guidance_save_state($form_state['values']['nid'], GUIDANCE_GUIDE_ON);
}


/**
 * Form for closing a guide.
 */
function guidance_block_closer_form($form_original, $nid) {
	return array(
		'nid' => array(
			'#type' => 'hidden',
			'#value' => $nid,
		),
		'submit' => array(
			'#type' => 'submit',
			'#value' => 'Close guide',
		),
    '#submit' => array('guidance_block_closer_form_submit'),
	);
}


/**
 * Submission for the closer form.
 */
function guidance_block_closer_form_submit($form, $form_state) {
	guidance_save_state($form_state['values']['nid'], GUIDANCE_GUIDE_OFF);
}